/**
 * Trida na vytvareni logovaciho souboru.
 *
 * FILE: FileLog.java
 * @author Martin Sloup (A04372), 13. krouzek, FAV - Informatika
 * @version 1.0, 12/04/04
 */
// naimportujeme potrebne balicky
import java.io.*;
 
public class FileLog {
	private boolean is_open = false;
	private PrintWriter fPrint;
	private File oFile;
	
	/**
	 * Konstruktor objektu; otevreni souboru, pripadne jeho zalozeni
	 */
	public FileLog(String filename) {
		// osetrime vyjjimky
		try {
			// vytvoreni objektu typu File
			this.oFile = new File(filename);
			// existuje soubor? pokud ne, zalozime ho
			if (!this.oFile.exists()) this.oFile.createNewFile();
			// vytvoreni objektu typu PrintWriter
			this.fPrint = new PrintWriter(new FileWriter(oFile));
			this.is_open = true;
		} catch(IOException e) {
			this.is_open = false;
			System.out.println("Nastala chyba pri praci se souborem!");
			e.printStackTrace();
		}
	}
	
	/**
	 * Destruktor objektu; uzavreni souboru, pokud jsme ho zapomneli zavrit
	 */
	protected void finalize() throws Throwable {
		// pokud je otevren soubor, uzavreme ho
		if (this.is_open) {
			this.fPrint.close();
			this.fPrint = null;
			this.oFile = null;
		}
		super.finalize();
	}
	
	/**
	 * Zapis do souboru
	 */
	public void print(String text) {
		// pokud je otevren soubor, zapisem do nej
		if (this.is_open) this.fPrint.print(text);
	}
	
	/**
	 * Zapis do souboru a pridani noveho radku
	 */
	public void println(String text) {
		// pokud je otevren soubor, zapisem do nej
		if (this.is_open) this.fPrint.println(text);
	}

	/**
	 * Zapis do souboru a pridani noveho radku
	 */
	public void println() {
		// pokud je otevren soubor, zapisem do nej
		if (this.is_open) this.fPrint.println();
	}
	
	/**
	 * Uzavreni souboru
	 */
	public void close() {
		// pokud je otevren soubor, uzavreme ho
		if (this.is_open) {
			this.fPrint.close();
			this.fPrint = null;
			this.oFile = null;
		}
	}
}